import {Component, Input, OnInit} from '@angular/core';
import {InventorySlot} from "../../../../project/game-model/inventory/intentory-slots/InventorySlot";
import {ItemGroup} from "../../../../project/game-model/inventory/ItemGroup";
import {MatTableDataSource} from "@angular/material/table";
import {MatDialog} from "@angular/material/dialog";
import {
  RequieredInheritancesCreatorComponent
} from "./requiered-inheritances-creator/requiered-inheritances-creator.component";

@Component({
  selector: 'app-requiered-inheritances-editor',
  templateUrl: './requiered-inheritances-editor.component.html',
  styleUrl: './requiered-inheritances-editor.component.scss'
})
export class RequieredInheritancesEditorComponent implements OnInit{

  @Input() inventorySlot: InventorySlot | undefined
  @Input() itemgroups: ItemGroup[] = []

  datasource: MatTableDataSource<ItemGroup> = new MatTableDataSource<ItemGroup>();
  displayedColumns: string[] = ['itemgroupName', 'itemgroupDescription', 'delete']

  constructor(private dialog: MatDialog) {
  }

  ngOnInit() {
    this.datasource.data = this.inventorySlot!.requiredInheritances;
  }

  addInheritance() {
    const dialogRef = this.dialog.open(RequieredInheritancesCreatorComponent, {
      data: this.itemgroups,
      width: "400px"
    })

    dialogRef.afterClosed().subscribe(res => {
      if(res != undefined) {
        console.log("Added")
        this.inventorySlot!.addRequieredInheritence(res);
        this.datasource.data = this.inventorySlot!.requiredInheritances;
      }
    })
  }

  deleteRequieredInheritence(requieredInheritence: ItemGroup) {
    this.inventorySlot!.removeRequieredInheritence(requieredInheritence)
    this.datasource.data = this.inventorySlot!.requiredInheritances;
  }
}
