import {ScriptAccount} from "../../scriptAccounts/ScriptAccount";
import {Action} from "../../interactions/actions/Action";
import {CharacterDependency} from "../../interactions/CharacterDependency";

export class ScriptAccountAction extends Action{
  scriptAccount: ScriptAccount
  changingValue: number = 0;


  constructor(scriptAccount: ScriptAccount, changingValue: number) {
    super(CharacterDependency.NONE);
    this.scriptAccount = scriptAccount;
    this.changingValue = changingValue;
  }


  combineActions(otherAction: ScriptAccountAction) {
    if(otherAction.scriptAccount === this.scriptAccount) {
      return new ScriptAccountAction(this.scriptAccount, this.changingValue + otherAction.changingValue)
    } else {
      return undefined;
    }
  }
}
