import {Character} from "../characters/Character";
import {Condition} from "./condition/Condition";
import {Action} from "./actions/Action";
import {AbstractInteraction} from "./AbstractInteraction";

export class Interaction extends AbstractInteraction{

  actions: Action[] = []


  constructor(sourceCharacter: Character, targetCharacter: Character | undefined, interactionLabel: string) {
    super(sourceCharacter, targetCharacter, interactionLabel);
  }

  equals(other: AbstractInteraction): boolean {
    if(!(other instanceof Interaction)) {
      return false;
    }

    const equealCharacters = this.sourceCharacter === other.sourceCharacter && this.targetCharacter === other.targetCharacter;
    const equalLabels = this.interactionLabel === other.interactionLabel;
    const equalConditions = this.conditions.every(condition => other.conditions.includes(condition)) && other.conditions.every(condition => this.conditions.includes(condition));

    const equalActions = this.actions.every(action => other.actions.includes(action) && other.actions.every(action => this.actions.includes(action)));

    return equealCharacters && equalLabels && equalConditions && equalActions;
  }

  validate(requieredCharacter: Character): boolean {
    const validCharacters = this.sourceCharacter == requieredCharacter || this.targetCharacter == requieredCharacter;
    const validLabel = this.interactionLabel.length > 0;
    //Todo: Check for contradicting conditions as well as double conditions and actions

    return validCharacters && validLabel;
  }


}
