import {ItemGroupCharacteristic} from "../ItemgroupCharacteristic";
import {InventoryCharacteristic} from "./InventoryCharacteristic";
import {ItemGroup} from "../ItemGroup";

export class InventorySlot {

  slotName: string
  slotCharacteristics: InventoryCharacteristic[] = []
  requiredInheritances: ItemGroup[] = [] //if empty: non reqierements
  combinable: boolean = false;


  constructor(slotName: string) {
    this.slotName = slotName;
  }

  addSlotCharacteristic(slotCharacteristic: InventoryCharacteristic) {
    const found = this.slotCharacteristics.find(characteristiic => characteristiic.increasingCharacteristic === slotCharacteristic.increasingCharacteristic
      && characteristiic.decreasingCharacteristic === slotCharacteristic.decreasingCharacteristic)
    if(found == undefined) {
      this.slotCharacteristics.push(slotCharacteristic);
    }
  }

  addRequieredInheritence(itemgroup: ItemGroup) {
    if(this.requiredInheritances.find(group => group.componentName === itemgroup.componentName) == undefined) {
      this.requiredInheritances.push(itemgroup);
    }
  }

  removeRequieredInheritence(itemgroup: ItemGroup) {
    this.requiredInheritances = this.requiredInheritances.filter(group => group.componentName !== itemgroup.componentName)
  }
}
