import {ModelComponentCreator} from "./ModelComponentCreator";
import {GameModel} from "../../GameModel";
import {ModelComponent} from "../../ModelComponent";
import {Item} from "../../inventory/Item";
import {ModelComponentType} from "../../ModelComponentType";
import {ConcreteItemGroup} from "../../inventory/ConcreteItemGroup";
import {ItemGroup} from "../../inventory/ItemGroup";

export class ItemCreator extends ModelComponentCreator {


  constructor(context: string, gameModel: GameModel, selectedComponent: ModelComponent | undefined) {
    super(context, gameModel, selectedComponent);
  }

  createModelComponent(): ModelComponent | undefined {
    if(this.selectedComponent != undefined && this.selectedComponent instanceof ConcreteItemGroup) {
      const item =  new Item("New Item", "", ModelComponentType.ITEM);
      this.selectedComponent.addItem(item, this.getInheritedGroups(this.selectedComponent))
      return item;
    } else {
      return undefined
    }
  }

  private getInheritedGroups(baseGroup: ItemGroup): ItemGroup[] {
    const itemgroups: ItemGroup[] = []
    let currentGroup: ItemGroup | undefined = baseGroup;
    while(currentGroup != undefined) {
      itemgroups.push(currentGroup);
      currentGroup = currentGroup.parentGroup;
    }
    return itemgroups;
  }


}
