import {ModelComponentCreator} from "./ModelComponentCreator";
import {GameModel} from "../../GameModel";
import {ModelComponent} from "../../ModelComponent";
import {ScriptAccount} from "../../scriptAccounts/ScriptAccount";

export class ScriptAccountCreator extends ModelComponentCreator {

  constructor(context: string, gameModel: GameModel, selectedComponent: ModelComponent | undefined) {
    super(context, gameModel, selectedComponent);
  }

  createModelComponent(): ModelComponent | undefined {
    const scriptAccount = new ScriptAccount("New ScriptAccount", "");
    if(this.gameModel.addScriptAccount(scriptAccount)) {
      return scriptAccount;
    } else {
      return undefined;
    }
  }


}
