import {Component, EventEmitter, Input, NgZone, Output} from '@angular/core';
import {ElectronService} from "../../core/services";
import {GameModel} from "../../project/game-model/GameModel";
import {ScriptAccount} from "../../project/game-model/scriptAccounts/ScriptAccount";
import {Overview} from "../Overview";

@Component({
  selector: 'app-script-account-overview',
  templateUrl: './script-account-overview.component.html',
  styleUrl: './script-account-overview.component.css'
})
export class ScriptAccountOverviewComponent implements Overview{
  @Input("gameModel") gameModel: GameModel | undefined
  @Output("onOpenScriptAccount") openScriptAccountEmitter: EventEmitter<ScriptAccount> = new EventEmitter<ScriptAccount>();

  selectedScriptAccount: ScriptAccount | undefined

  constructor() {
  }

  refresh(): void {
    //Nothing to do
  }

  onOpenScriptAccount(scriptAccount: ScriptAccount) {
    console.log("onOpenScriptAccount (overview)")
    this.openScriptAccountEmitter.emit(scriptAccount);
  }



  selectScriptAccount(scriptAccount: ScriptAccount) {
    this.selectedScriptAccount = scriptAccount;
  }
}
